#!/bin/sh

set -e
set -x

i=0
while [ -f /var/log/libvirt/qemu/${$}-${i}.log ]; do
    i=$((i + 1))
done
name="${$}-${i}"
mac="$(./randmac.py)"
uuid="$(uuidgen)"
xml=$(mktemp)
cp template.xml $xml

cleanup() {
    sudo virsh destroy $name
    sudo virsh undefine $name --nvram
    rm -f ./vms/${name}.img ./vms/${name}_CODE.fd ./vms/${name}_VARS.fd $xml
}

trap cleanup EXIT

mkdir -p vms

dd if=/dev/zero of=./vms/${name}_CODE.fd bs=1M count=64
dd if=/usr/share/qemu-efi/QEMU_EFI.fd of=./vms/${name}_CODE.fd conv=notrunc
dd if=/dev/zero of=./vms/${name}_VARS.fd bs=1M count=64
qemu-img create -f qcow2 -o backing_file=$(pwd)/zesty-server-cloudimg-arm64.img ./vms/${name}.img
sed -i "s/\#VM\#/$name/" $xml
sed -i "s,\#DIR\#,$(pwd)," $xml
sed -i "s/\#UUID\#/$uuid/" $xml
sed -i "s/\#MAC\#/$mac/" $xml

sudo virsh define $xml
sudo virsh start $name
sleep 60
sudo virsh save $name /tmp/$name.sav
sudo virsh restore /tmp/$name.sav
sleep 5
sudo virsh save $name /tmp/$name.sav
sudo virsh restore /tmp/${name}.sav
sudo virsh save $name /tmp/${name}.sav
sudo virsh restore /tmp/${name}.sav


